/// @addtogroup diffIncl
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file DiffInclusionCW.h
///
/// @author Tomasz Kapela
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file constitutes a part of the CAPD library, 
// distributed under the terms of the GNU General Public License.
// Consult  http://capd.wsb-nlu.edu.pl/ for details. 

/* Author: Tomasz Kapela, 2007 */

#ifndef _CAPD_DIFFINCL_DIFFINCLUSIONCW_H_ 
#define _CAPD_DIFFINCL_DIFFINCLUSIONCW_H_ 

#include "diffIncl/DiffInclusion.h"

namespace capd{
namespace diffIncl{

template<typename MapT>
class DiffInclusionCW : public capd::diffIncl::DiffInclusion<MapT>{

public:
  typedef typename DiffInclusion<MapT>::MultiMapType   MultiMapType;
  typedef typename DiffInclusion<MapT>::MapType        MapType;
  typedef typename DiffInclusion<MapT>::FunctionType   FunctionType;
  typedef typename DiffInclusion<MapT>::MatrixType     MatrixType;
  typedef typename DiffInclusion<MapT>::VectorType     VectorType;
  typedef typename DiffInclusion<MapT>::ScalarType     ScalarType;
  typedef typename DiffInclusion<MapT>::NormType       NormType;
  
  DiffInclusionCW( MultiMapType & diffIncl, 
                   int order, 
                   ScalarType const & step,
                   NormType const & norm
  );

  VectorType perturbations(const VectorType & x);

  using DiffInclusion<MapT>::enclosure;
  using DiffInclusion<MapT>::diffInclusionEnclosure;
  using DiffInclusion<MapT>::dynamicalSystemEnclosure;
  using DiffInclusion<MapT>::getStep;

protected:
 // DiffInclusionCW(const DiffInclusionCW &){};
 // void operator=(const DiffInclusionCW &){};
  using DiffInclusion<MapT>::m_norm;
  using DiffInclusion<MapT>::m_diffIncl;
  
  
};


}} // namespace capd::diffIncl

#endif // _CAPD_DIFFINCL_DIFFINCLUSIONCW_H_ 

/// @}
