/// @addtogroup dynset
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file dynsetlib.h
///
/// @author Daniel Wilczak
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file constitutes a part of the CAPD library, 
// distributed under the terms of the GNU General Public License.
// Consult  http://capd.wsb-nlu.edu.pl/ for details. 

/* Author: Daniel Wilczak 2005 */

#ifndef _CAPD_DYNSET_DYNSETLIB_H_ 
#define _CAPD_DYNSET_DYNSETLIB_H_ 

#include "interval/doubleInterval.h"
#include "vectalg/vectalglib.h"

#include "dynset/BallSet.h"
#include "dynset/EllipsoidSet.h"
#include "dynset/FlowballSet.h"
#include "dynset/Intv2Set.h"
#include "dynset/IntvSet.h"
#include "dynset/Pped2Set.h"
#include "dynset/PpedSet.h"
#include "dynset/Rect2Set.h"
#include "dynset/RectSet.h"

#include "dynset/C1Rect.h"
#include "dynset/C1Rect2.h"
#include "dynset/C11Rect2.h"
#include "dynset/C2Rect2.h"

typedef interval (*v_form)(IVector &);
typedef capd::dynset::C0Set<IMatrix> C0Set;
typedef capd::dynset::BallSet<IMatrix> BallSet;
typedef capd::dynset::EllipsoidSet<DVector,IMatrix> EllipsoidSet;
typedef capd::dynset::FlowballSet<IMatrix> FlowballSet;
typedef capd::dynset::Intv2Set<IMatrix> Intv2Set;
typedef capd::dynset::IntervalSet<IMatrix> IntervalSet;
typedef capd::dynset::Pped2Set<IMatrix> Pped2Set;
typedef capd::dynset::PpedSet<IMatrix> PpedSet;
typedef capd::dynset::Rect2Set<IMatrix> Rect2Set;
typedef capd::dynset::RectSet<IMatrix> RectSet;

typedef capd::dynset::C1Set<IMatrix> C1Set;
typedef capd::dynset::C1Rect<IMatrix> C1Rect;
typedef capd::dynset::C1Rect2<IMatrix> C1Rect2;
typedef capd::dynset::C11Rect2<IMatrix> C11Rect2;

typedef capd::dynset::C2Set<IMatrix> C2Set;
typedef capd::dynset::C2Rect2<IMatrix> C2Rect2;

#endif // _CAPD_DYNSET_DYNSETLIB_H_ 

/// @}
