/// @addtogroup matrixAlgorithms
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file floatMatrixAlgorithms.cpp
///
/// @author The CAPD Group
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file constitutes a part of the CAPD library, 
// distributed under the terms of the GNU General Public License.
// Consult  http://capd.wsb-nlu.edu.pl/ for details. 

#include "capd/minmax.h"
#include "vectalg/vectalglib.h"
#include "matrixAlgorithms/floatMatrixAlgorithms.hpp"

template void capd::matrixAlgorithms::orthonormalize<DMatrix>(DMatrix&);
template void capd::matrixAlgorithms::orthonormalize<IMatrix>(IMatrix&);

template void capd::matrixAlgorithms::QR_decompose<DMatrix>(const DMatrix&,DMatrix&,DMatrix&);
template void capd::matrixAlgorithms::QR_decompose<IMatrix>(const IMatrix&,IMatrix&,IMatrix&);

template int capd::matrixAlgorithms::symMatrixDiagonalize<DMatrix>(const DMatrix&,DMatrix&,double);
template int capd::matrixAlgorithms::symMatrixDiagonalize<IMatrix>(const IMatrix&,IMatrix&,interval);

template double capd::matrixAlgorithms::spectralRadiusOfSymMatrix<DMatrix>(const DMatrix&,double);
template interval capd::matrixAlgorithms::spectralRadiusOfSymMatrix<IMatrix>(const IMatrix&,interval);

template double capd::matrixAlgorithms::maxEigenValueOfSymMatrix<DMatrix>(const DMatrix&,double);
template interval capd::matrixAlgorithms:: maxEigenValueOfSymMatrix<IMatrix>(const IMatrix&,interval);

template DVector capd::matrixAlgorithms::gauss<DMatrix,DVector>(DMatrix, DVector);
template IVector capd::matrixAlgorithms::gauss<IMatrix,IVector>(IMatrix,IVector);

template void capd::matrixAlgorithms::croutDecomposition<DMatrix>(const DMatrix&,DMatrix&,DMatrix&);
template void capd::matrixAlgorithms::croutDecomposition<IMatrix>(const IMatrix&,IMatrix&,IMatrix&);

template DMatrix capd::matrixAlgorithms::invLowerTriangleMatrix<DMatrix>(const DMatrix&);
template IMatrix capd::matrixAlgorithms::invLowerTriangleMatrix<IMatrix>(const IMatrix&);

template DMatrix capd::matrixAlgorithms::invUpperTriangleMatrix<DMatrix>(const DMatrix&);
template IMatrix capd::matrixAlgorithms::invUpperTriangleMatrix<IMatrix>(const IMatrix&);

template DMatrix capd::matrixAlgorithms::inverseMatrix<DMatrix>(const DMatrix&);
template IMatrix capd::matrixAlgorithms::inverseMatrix<IMatrix>(const IMatrix&);

template DMatrix capd::matrixAlgorithms::gaussInverseMatrix<DMatrix>(const DMatrix);
template IMatrix capd::matrixAlgorithms::gaussInverseMatrix<IMatrix>(const IMatrix);

/// @}
