/// @addtogroup vectalg
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file DMatrixMD.cpp
///
/// @author The CAPD Group
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file constitutes a part of the CAPD library, 
// distributed under the terms of the GNU General Public License.
// Consult  http://capd.wsb-nlu.edu.pl/ for details. 

#include "vectalg/dimension.h"
#include "vectalg/Vector.hpp"
#include "vectalg/Matrix.hpp"

using namespace capd::vectalg;

template class Matrix<double,0,0>;
template class RowVector<double,0>;
template class ColumnVector<double,0>;

template Matrix<double,0,0> abs <double,0,0> (const Matrix<double,0,0>&);
template Matrix<double,0,0> operator- <double,0,0> (const Matrix<double,0,0>&);
template Matrix<double,0,0> operator+ <double,0,0> (const Matrix<double,0,0>&, const Matrix<double,0,0>&);
template Matrix<double,0,0> operator- <double,0,0> (const Matrix<double,0,0>&, const Matrix<double,0,0>&);
template Matrix<double,0,0> operator* <double,0,0> (const Matrix<double,0,0>&, const Matrix<double,0,0>&);
template Vector<double,0> operator* <double,0,0> (const Matrix<double,0,0>&, const Vector<double,0>&);
template Matrix<double,0,0> operator* <double,0,0> (const Matrix<double,0,0>&, const double&);
template Matrix<double,0,0> operator* <double,0,0> (const double&, const Matrix<double,0,0>&);
template Matrix<double,0,0> operator/ <double,0,0> (const Matrix<double,0,0>&, const double&);
template Matrix<double,0,0> operator+ <double,0,0> (const Matrix<double,0,0>&, const double&);
template Matrix<double,0,0> operator- <double,0,0> (const Matrix<double,0,0>&, const double&);
template bool operator< <double,0,0> (const Matrix<double,0,0>&, const Matrix<double,0,0>&);
template bool operator> <double,0,0> (const Matrix<double,0,0>&, const Matrix<double,0,0>&);
template bool operator<= <double,0,0> (const Matrix<double,0,0>&, const Matrix<double,0,0>&);
template bool operator>= <double,0,0> (const Matrix<double,0,0>&, const Matrix<double,0,0>&);
template Matrix<double,0,0> Transpose <double,0,0> (const Matrix<double,0,0>&);
template std::ostream &operator<< <double,0,0> (std::ostream&, const Matrix<double,0,0>&);
template std::istream &operator>> <double,0,0> (std::istream&, Matrix<double,0,0>&);


// RowVector

template Vector<double,0> operator+<double,0>(
      const Vector<double,0>&,
      const RowVector<double,0>&
   );
template Vector<double,0> operator+<double,0>(
      const RowVector<double,0>&,
      const Vector<double,0>&
   );
template Vector<double,0> operator+<double,0>(
      const RowVector<double,0>&,
      const RowVector<double,0>&
   );

template Vector<double,0> operator-<double,0>(
      const Vector<double,0>&,
      const RowVector<double,0>&
   );
template Vector<double,0> operator-<double,0>(
      const RowVector<double,0>&,
      const Vector<double,0>&
   );
template Vector<double,0> operator-<double,0>(
      const RowVector<double,0>&,
      const RowVector<double,0>&
   );

template double operator*<double,0>(
      const Vector<double,0>&,
      const RowVector<double,0>&
   );
template double operator*<double,0>(
      const RowVector<double,0>&,
      const Vector<double,0>&
   );
template double operator*<double,0>(
      const RowVector<double,0>&,
      const RowVector<double,0>&
   );

template Vector<double,0> operator-<double,0>(const RowVector<double,0>&);
template Vector<double,0> operator*<double,0,0>(
      const Matrix<double,0,0>&, const RowVector<double,0>&
   );

template Vector<double,0> operator*<double,0>(const double&, const RowVector<double,0>&);
template Vector<double,0> operator*<double,0>(const RowVector<double,0>&, const double&);
template Vector<double,0> operator/<double,0>(const RowVector<double,0>&, const double&);

template std::ostream& operator<< <double,0>(std::ostream&, const RowVector<double,0>&);


// ColumnVector

template Vector<double,0> operator+<double,0>(
      const Vector<double,0>&,
      const ColumnVector<double,0>&
   );
template Vector<double,0> operator+<double,0>(
      const ColumnVector<double,0>&,
      const Vector<double,0>&
   );
template Vector<double,0> operator+<double,0>(
      const ColumnVector<double,0>&,
      const ColumnVector<double,0>&
   );

template Vector<double,0> operator-<double,0>(
      const Vector<double,0>&,
      const ColumnVector<double,0>&
   );
template Vector<double,0> operator-<double,0>(
      const ColumnVector<double,0>&,
      const Vector<double,0>&
   );
template Vector<double,0> operator-<double,0>(
      const ColumnVector<double,0>&,
      const ColumnVector<double,0>&
   );

template double operator*<double,0>(
      const Vector<double,0>&,
      const ColumnVector<double,0>&
   );
template double operator*<double,0>(
      const ColumnVector<double,0>&,
      const Vector<double,0>&
   );
template double operator*<double,0>(
      const ColumnVector<double,0>&,
      const ColumnVector<double,0>&
   );

template Vector<double,0> operator-<double,0>(const ColumnVector<double,0>&);
template Vector<double,0> operator*<double,0,0>(
      const Matrix<double,0,0>&,
      const ColumnVector<double,0>&
   );

template Vector<double,0> operator*<double,0>(const double&, const ColumnVector<double,0>&);
template Vector<double,0> operator*<double,0>(const ColumnVector<double,0>&, const double&);
template Vector<double,0> operator/<double,0>(const ColumnVector<double,0>&, const double&);

template std::ostream& operator<< <double,0>(std::ostream&, const ColumnVector<double,0>&);

/// @}
